#ifndef __ZCALCHF_INCLUDED__
#define __ZCALCHF_INCLUDED__

#pragma once

bool zCalcHF_Perlin(ZMAP pHF, float FeatureScale, int nOctaves, float Persistence, float MeanAlt, float AltRange, int NoiseKey, bool ShowProgress);
bool zCalcHF_Fractal(ZMAP pHF, int PowerOfTwo, float Roughness, float AltRange, bool WrapFlag, bool ShowProgress);

bool zCalcHF_CurvFilter(ZMAP pHF, long nLevels, long nLevelsPerBlock, float Threshold, bool ShowProgress);
bool zCalcHF_Clamp(ZMAP pHF, float MinAlt, float MaxAlt, bool ShowProgress);
bool zCalcHF_Shift(ZMAP pHF, float AltShift, bool ShowProgress);
bool zCalcHF_Scale(ZMAP pHF, float Factor, bool ShowProgress);
bool zCalcHF_Power(ZMAP pHF, float Index, bool ShowProgress);
bool zCalcHF_Min(ZMAP pHF, float MinAlt, bool ShowProgress);
bool zCalcHF_Max(ZMAP pHF, float MaxAlt, bool ShowProgress);

bool zCalcHF_Inflate(ZMAP pHF, ZMAP pDM, long nLevels, float FractalFactor = 1.0f);
bool zCalcHF_InflateMosaic(ZMAP pMapSrc, ZMAP pMapDest, const char* lpFileName, const char* lpMapName, long TileSize, ZFORMAT pFormat, ZMAP pDM, long nLevels, float FractalFactor = 1.0f);

bool zCalcHF_PeakPass(ZMAP pHF, ZMAP pDM);
bool zCalcHF_MountainPass(ZMAP pHF, ZMAP pDM);
bool zCalcHF_VolcanoPass(ZMAP pHF, ZMAP pDM);
bool zCalcHF_PlateauPass(ZMAP pHF, ZMAP pDM);
bool zCalcHF_TerracePass(ZMAP pHF, ZMAP pDM);
bool zCalcHF_FileOverlayPass(ZMAP pHF, ZMAP pDM);
bool zCalcHF_ThermalPass(ZMAP pHF, ZMAP pDM, int nLevelMultiplier, int LevelOffset, int MaxLength, float S, float GradThreshold);
bool zCalcHF_ChannelPass(ZMAP pHF, ZMAP pDM, int nLevelMultiplier, int LevelOffset, int MinLength, int MaxLength, float DeltaHF, float MemDecay, bool BlurDir);

bool zCalcHF_GenPeakOverlay(ZMAP pHF, int Radius, float Height, int ShapeMode);

bool zCalcHF_CombineMapsEx(ZMAP pHF, ZMAP pOverlay, int MixMode, int xOffset, int yOffset, int xOffsetMode, int yOffsetMode);

#endif