#include "..\Plugin API\ExtAPI.h"
#include "zCalcMan.h"
#include "..\Plugin API\zVar.h"
#include "..\Plugin API\zStr.h"
#include "..\Plugin API\zFunc.h"
#include "..\Plugin API\zList.h"

extern CExtAPI theAPI;

bool zCalcMan_IsBusy() {

	CzVar v;
	v.Create(VarID_bool);

	if(!theAPI.script_Execute("zs", "calcman.IsBusy", (ZVAR)v)) { 
		return false;
	}

	bool b = false;
	if(!v.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}

void zCalcMan_Abort() {

	theAPI.script_Execute("zs", "calcman.Abort", NULL);
}

bool zCalcMan_RunCalcScript(const char* lpScript) {
	CzVar v;
	v.Create(VarID_bool);

	CzStr s;
	s.SetText("calcman.RunCalcScript \"");
	s.Append(lpScript);
	s.Append("\"");

	if(!theAPI.script_Execute("zs", (char*)s, (ZVAR)v)) { 
		return false;
	}

	bool b = false;
	if(!v.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMan_StartCalcProgress(const char* lpTitle, bool ShowProgBar, bool EstimateTime) {
	CzFunc f;
	if(!f.GetFunc("calcman.StartCalcProgress")) {
		return false;
	}
	if(!theAPI.str_SetText(f.m_args.GetItem((long)0), lpTitle)) {
		return false;
	}
	if(!f.m_args.SetItemValue(1, VarID_bool, &ShowProgBar)) {
		return false;
	}
	if(!f.m_args.SetItemValue(2, VarID_bool, &EstimateTime)) {
		return false;
	}

	if(!f.Execute2()) {
		return false;
	}

	bool b;
	if(!f.m_rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMan_StartCalcProgressGrid(const char* lpTitle, long PaletteMode, bool ShowProgBar, bool EstimateTime) {
	CzFunc f;
	if(!f.GetFunc("calcman.StartCalcProgressGrid")) {
		return false;
	}
	if(!theAPI.str_SetText(f.m_args.GetItem((long)0), lpTitle)) {
		return false;
	}
	if(!f.m_args.SetItemValue(1, VarID_int, &PaletteMode)) {
		return false;
	}
	if(!f.m_args.SetItemValue(2, VarID_bool, &ShowProgBar)) {
		return false;
	}
	if(!f.m_args.SetItemValue(3, VarID_bool, &EstimateTime)) {
		return false;
	}

	if(!f.Execute2()) {
		return false;
	}

	bool b;
	if(!f.m_rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}

bool zCalcMan_AddCalcStage(const char* lpStageName) {
	CzVar v;
	v.Create(VarID_bool);

	CzStr s;
	s.SetText("calcman.AddCalcStage \"");
	s.Append(lpStageName);
	s.Append("\"");

	if(!theAPI.script_Execute("zs", (char*)s, (ZVAR)v)) { 
		return false;
	}

	bool b = false;
	if(!v.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMan_AdvanceCalcStage() {
	CzVar v;
	v.Create(VarID_bool);
	if(!theAPI.script_Execute("zs", "calcman.AdvanceCalcStage", (ZVAR)v)) { 
		return false;
	}
	bool b = false;
	if(!v.GetValue(VarID_bool, &b)) {
		return false;
	}
	return b;
}



bool zCalcMan_SetCalcProgress(__int64 p, __int64 pmax) {
	CzFunc f;
	if(!f.GetFunc("calcman.SetCalcProgress")) {
		return false;
	}
	if(!f.m_args.SetItemValue((long)0, VarID_int64, &p)) {
		return false;
	}
	if(!f.m_args.SetItemValue(1, VarID_int64, &pmax)) {
		return false;
	}

	if(!f.Execute2()) {
		return false;
	}

	bool b;
	if(!f.m_rval.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
bool zCalcMan_SetCalcTitle(const char* lpTitle) {
	CzVar v;
	v.Create(VarID_bool);

	CzStr s;
	s.SetText("calcman.SetCalcTitle \"");
	s.Append(lpTitle);
	s.Append("\"");

	if(!theAPI.script_Execute("zs", (char*)s, (ZVAR)v)) { 
		return false;
	}

	bool b = false;
	if(!v.GetValue(VarID_bool, &b)) {
		return false;
	}

	return b;
}
void zCalcMan_HideCalcProgress() {
	theAPI.script_Execute("zs", "calcman.HideCalcProgress", NULL);
}
bool zCalcMan_ProgMapInit(ZMAP* phMap, long nx, long ny, long MapTypeID, bool WrapFlag) {
	CzFunc f;
	if(!f.GetFunc("calcman.ProgMapInit")) {
		return false;;
	}
	if(!f.m_args.SetItemValue((long)0, VarID_int, &nx)) {
		return false;
	}
	if(!f.m_args.SetItemValue(1, VarID_int, &ny)) {
		return false;
	}
	if(!f.m_args.SetItemValue(2, VarID_int, &MapTypeID)) {
		return false;
	}
	if(!f.m_args.SetItemValue(3, VarID_bool, &WrapFlag)) {
		return false;
	}

	if(!f.Execute2()) {
		return false;
	}

	if(!f.m_rval.GetValue(VarID_hvar, phMap)) {
		return false;
	}

	if(!(*phMap)) {
		return false;
	}

	return true;
}
void zCalcMan_ProgMapFree() {
	theAPI.script_Execute("zs", "calcman.ProgMapFree", NULL);
}
