#ifndef __ZPROJECT_INCLUDED__
#define __ZPROJECT_INCLUDED__

#pragma once

// init state

bool zProj_IsInit();
bool zProj_Init();
bool zProj_Free();

// loading/saving project

bool zProj_LoadProject(const char* lpProjName);
bool zProj_SaveProject();		// project file and all unsaved maps
bool zProj_SaveProjectFile();	// just save the project file 
bool zProj_SaveProjectAs(const char* lpProjName);
bool zProj_DemandSave();

bool zProj_IsPathOK();
const char* zProj_GetProjectFilename();

// saving map

bool zProj_AutoSaveMap(const char* lpMapName);
bool zProj_AutoLoadMap(const char* lpMapName);

// settings and options

ZLIST	zProj_GetSettingsList();
bool	zProj_GetSetting(const char* lpName, long VarID, void* pValue);
bool	zProj_SetSetting(const char* lpName, long VarID, void* pValue);

bool	zProj_GetOpFlag(const char* lpOpName);
bool	zProj_SetOpFlag(const char* lpOpName, bool StateFlag);
bool	zProj_DelOpsFollowing(const char* lpOpName);

// accessing maps

ZLIST	zProj_GetMapList();
ZMAP	zProj_GetMap(const char* lpMapName);
ZMAP	zProj_CreateMap(const char* lpMapName);
ZMAP	zProj_GetOrCreateMap(const char* lpMapName);

bool	zProj_GetHeightfieldRange(float& minval, float& maxval);

bool	zProj_SetMapFlag(const char* lpMapName, long MapFlag, bool State);

bool	zProj_GetMapDisplayName(ZSTR hDest, const char* lpMapName);

// scale settings

long	zProj_GetCurTileSizeDM();
bool	zProj_SetCurTileSizeDM(long TileSizeDM);

float	zProj_GetCurHorizScaleHF();
bool	zProj_SetCurHorizScaleHF(float HorizScaleHF);

// climates

int		zProj_nClimates();
ZVAR	zProj_GetClimate(int CliID);
ZVAR	zProj_GetClimateA(const char* lpCliName);
int		zProj_GetClimateIndex(const char* lpCliName);
int 	zProj_AddClimateA(const char* lpCliName);

#endif