#include <ExtAPI.h>
#include "zXML.h"
#include <zClasses.h>
#include <zFunc.h>

extern CExtAPI theAPI;


bool zXML_Save(const char* lpFileName, ZLIST hData) {

	CzFunc f;
	if(!f.GetFunc("file.xml.Save")) {
		theAPI.ReportError("zXML_Save error:\r\n - cannot get function");
		return false;
	}
	int argid = 0;
	if(!theAPI.str_SetText(f.GetArgI(argid++), lpFileName)) {
		theAPI.ReportError("zXML_Save error:\r\n - cannot set arg");
		return false;
	}
	if(!f.SetArgValueI(argid++, VarID_hvar, &hData)) {
		theAPI.ReportError("zXML_Save error:\r\n - cannot set arg");
		return false;
	}

	if(!f.Execute2()) {
		theAPI.ReportError("zXML_Save error:\r\n - function call failed");
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		theAPI.ReportError("zXML_Save error:\r\n - cannot get value var");
		return false;
	}

	return rval;
}
bool zXML_Load(const char* lpFileName, ZLIST hData) {
	CzFunc f;
	if(!f.GetFunc("file.xml.Load")) {
		theAPI.ReportError("zXML_Load error:\r\n - cannot get function");
		return false;
	}
	int argid = 0;
	if(!theAPI.str_SetText(f.GetArgI(argid++), lpFileName)) {
		theAPI.ReportError("zXML_Load error:\r\n - cannot set arg");
		return false;
	}
	if(!f.SetArgValueI(argid++, VarID_hvar, &hData)) {
		theAPI.ReportError("zXML_Load error:\r\n - cannot set arg");
		return false;
	}

	if(!f.Execute2()) {
		theAPI.ReportError("zXML_Load error:\r\n - function call failed");
		return false;
	}

	bool rval = false;
	if(!f.m_rval.GetValue(VarID_bool, &rval)) {
		theAPI.ReportError("zXML_Load error:\r\n - cannot get value var");
		return false;
	}

	return rval;
}
