#pragma once
#include "zvar.h"

class CzFormat :
	public CzVar
{
public:
	CzFormat(void);
	~CzFormat(void);

	bool	Create(const char* lpMapName, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName);
	bool	CreateGeneric(long MapTypeID, const char* lpLongName, const char* lpFileExt, const char* lpNativeProgramName);
	bool	GetByExt(const char* lpMapName, long MapTypeID, const char* lpFileExt);
	bool	GetByExt2(ZMAP hMap, const char* lpFileExt);
	bool	GetActiveFormat(const char* lpMapName, long MapTypeID);
	bool	GetDefaultFormat(const char* lpMapName, long MapTypeID);

	bool	SetFlags(bool Native, bool Mosaic); // deprecated 30 Sept '08 (v2.6); use SetFlags2 instead
	bool	SetFlags2(unsigned long Flags);
	unsigned long	GetFlags();
	bool	SetInfoStr(const char* lpInfoStr);
	const char*	GetExt();
	ZLIST	GetOptionList();
	bool	GetOptionValue(const char* lpOptionName, long VarID, void* pValue);
	bool	SetOptionValue(const char* lpOptionName, long VarID, void* pValue);
	bool	IsMosaic(); // deprecated 30 Sept '08 (v2.6); use GetFlags instead
	bool	IsNative(); // deprecated 30 Sept '08 (v2.6); use GetFlags instead
};
